--The function to get the colour table when we place a new Tile.
function vzyGetTileColour(tileValue)
	return remote.call("vzyColouredTilesBits", "getColour", tileValue)
end
function vzyBuildTiled(tileValue, tilePosition)
	local bob = game.player.surface.create_entity({name="player", position=tilePosition})
	bob.color = vzyGetTileColour(tileValue)
	local bobsRide = game.player.surface.create_entity({name="coloured-tile-Car", position=tilePosition})
	bobsRide.passenger = bob
	return bobsRide
end

function On_Built(event)
	local entity = event.created_entity
	if isUs(entity.name) then
		local x = entity.position.x
		local y = entity.position.y
		local value = loadValue(entity.position)
		if not global.vzyColouredTiles then
			global.vzyColouredTiles = {}
		end
		if not global.vzyColouredTiles[x] then
			global.vzyColouredTiles[x] = {}
		end
		if global.vzyColouredTiles[x][y] then
			--Kill the last one.
			killAt(x,y)
		end
		global.vzyColouredTiles[x][y] = vzyBuildTiled(value, entity.position)
    end
end
function On_Removed(event)
	local entity = event.entity
	if isUs(entity.name) then
		local x = entity.position.x
		local y = entity.position.y
		killAt(x,y)
    end
end
function killAt(x,y)
	if global.vzyColouredTiles then
		if not global.vzyColouredTiles[x] then
			if global.vzyColouredTiles[x][y] then
				global.vzyColouredTiles[x][y].passenger.destroy()
				global.vzyColouredTiles[x][y].destroy()
				global.vzyColouredTiles[x][y] = nil
			end
		end
	end
end
function isUs(name)
	return string.find(name,"coloured-tile") ~= nil
end
function loadValue(position)
	if not global.vzyColouredTilesToDo then
		global.vzyColouredTilesToDo = {}
	end
	for i=1,#global.vzyColouredTilesToDo do
		if position == global.vzyColouredTilesToDo[i].position then
			local cur = global.vzyColouredTilesToDo[i]
			table.remove(global.vzyColouredTilesToDo, i)
			return cur.value
		end
	end
	return 0
end

game.on_event(defines.events.on_built_entity, function(event) On_Built(event) end)
game.on_event(defines.events.on_robot_built_entity, function(event) On_Built(event) end)
game.on_event(defines.events.on_preplayer_mined_item, function(event) On_Removed(event) end)
game.on_event(defines.events.on_robot_pre_mined, function(event) On_Removed(event) end)

game.on_event(defines.events.on_put_item, function(event)
		local item = game.players[event.player_index].cursor_stack.name
		if isUs(item) then
			if not global.vzyColouredTilesToDo then
				global.vzyColouredTilesToDo = {}
			end
			--"coloured-tile-lv"..level
			global.vzyColouredTilesToDo = {value=tonumber(string.sub(item,string.len("coloured-tile-lv")))-1, position=event.position}
		end
	end)
