function vzyGenerateLevelingThingName(name, level, maxLevel)
	local maxName = name .. "-lv" .. maxLevel
	local ourName = name .. "-lv"  .. level
	local dif = string.len(maxName) - string.len(ourName)
	if dif <= 0 then
		return ourName
	end
	local leader = ""
	while dif > 0 do
		leader = leader.."0"
		dif = dif - 1
	end
	return name .. "-lv"  .. leader .. level
end
function vzyGenerateLevelingThing(simpleThing, originalThing, levels)
	local names = simpleThing.nameAll
	local currentLevel = 1
	local lastName = originalThing.name
	while currentLevel <= levels do
		if type(nameAll) == "function" then
			simpleThing.nameAll = names
		else
			simpleThing.nameAll = vzyGenerateLevelingThingName(names, currentLevel, levels)
		end
		if simpleThing.previousCount then
			simpleThing.ingredients = simpleThing.ingredients or {}
			if type(simpleThing.previousCount) == "function" then
				simpleThing.ingredients[#simpleThing.ingredients + 1] = {lastName, simpleThing.previousCount(level)}
			else
				simpleThing.ingredients[#simpleThing.ingredients + 1] = {lastName, simpleThing.previousCount}
			end
		end
		lastName = vzyGenerateThing(simpleThing, originalThing, currentLevel).name 
		currentLevel = currentLevel + 1
	end
end
function vzyGenerateThing(simpleThing, originalThing, level)
	newCopy = table.deepcopy(originalThing)
	vzyGenerateThingCopyTo(simpleThing, newCopy, level)
	data:extend({newCopy})
	--data.raw[newCopy.type][newCopy.name] = newCopy
	return newCopy
end
function vzyGenerateThingCopyTo(simpleThing, newCopy, level)
	for key, value in pairs(simpleThing) do
		if type(value) == "function" then
			newCopy[key] = value(level)
		else
			if type(value) == "table" then
				newCopy[key] = {}
				vzyGenerateThingCopyTo(value, newCopy[key], level)
			else
				newCopy[key] = value
			end
		end
	end
	if newCopy.nameAll then
		vzyGenerateThingCopyToNameAll(newCopy.nameAll, newCopy)
	end
end
function vzyGenerateThingCopyToNameAll(nameAll, newCopy)
	newCopy.name = nameAll
	if newCopy.result then
		newCopy.result = nameAll
	end
	if newCopy.place_result then
		newCopy.place_result = nameAll
	end
	if newCopy.minable then
		if newCopy.minable.result then
			newCopy.minable.result = nameAll
		end
	end
	if newCopy.order then
		newCopy.order = newCopy.order .. ".-." .. nameAll
	end
	if newCopy.fixRecipeTech then
		newCopy.effects = {{recipe=nameAll, type="unlock-recipe"}}
		newCopy.fixRecipeTech = nil
	end
	--clean up after ourselves.
	newCopy.nameAll = nil
end
